<?php
/*
 * Joomla VirtueMart
 * Модуль для подключения платежной системы IntellectMoney
 *
Last Changed Rev: 13318
Last Changed Date: 2011-12-14 17:08:01 +0400 (Wed, 14 Dec 2011)
 */
?>
<?php
/*
 * Intellectmoney IPN Handler
 *
 * @version $Id: im_notify.php,v 1.0 beta 2008/04/02 14:10:18 esmark Exp $
 * @package VirtueMart
 * @subpackage core
 * @copyright Copyright (C) 2004-2005 Soeren Eberhardt. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.ru
 */

global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database,
	$mosConfig_mailfrom, $mosConfig_fromname;

function ob_exit($status = null)
{
	if($status) {
		ob_end_flush();
		isset($_REQUEST['debug']) ? exit($status) : exit();
	}
	else {
		ob_end_clean();
		header("HTTP/1.0 200 OK");
		echo "OK";
		exit();
	}
}

function debug_file()
{
	header('Content-type: text/plain; charset=utf-8');
	echo file_get_contents(__FILE__);
}

function check_im()
{
	$iplist = gethostbynamel('www.intellectmoney.ru');
	foreach($iplist as $ip)
		if(preg_match("/^$ip/", $_SERVER['HTTP_REFERER']))
			return true;
	return false;
}

function from_request($name)
{
	return isset($_REQUEST[$name]) ? trim(stripslashes($_REQUEST[$name])) : null;
}


if($_REQUEST['debug_file'])
	debug_file();
else
{
	ob_start();
	
	/*** access Joomla's configuration file ***/
	$my_path = dirname(__FILE__);
	
	if(file_exists($my_path."/../../../configuration.php"))
		$absolute_path = dirname($my_path."/../../../configuration.php");
	else if(file_exists($my_path."/../../configuration.php"))
		$absolute_path = dirname($my_path."/../../configuration.php");
	else if(file_exists($my_path."/configuration.php"))
		$absolute_path = dirname($my_path."/configuration.php");
	else
		ob_exit("ERROR: Joomla Configuration File not found!\n\n");
	
	require_once( $absolute_path."/configuration.php" );
	$absolute_path = realpath( $absolute_path );
	
	// Set up the appropriate CMS framework
	if(class_exists( 'jconfig' ))
	{
		define('_JEXEC', 1);
		define('JPATH_BASE', $absolute_path);
		define('DS', DIRECTORY_SEPARATOR);
		
		// Load the framework
		require_once( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
		require_once( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );
		
		// create the mainframe object
		$mainframe = & JFactory::getApplication( 'site' );
		
		// Initialize the framework
		$mainframe->initialise();
		
		// load system plugin group
		JPluginHelper::importPlugin( 'system' );
		
		// trigger the onBeforeStart events
		$mainframe->triggerEvent( 'onBeforeStart' );
		$lang =& JFactory::getLanguage();
		$mosConfig_lang = $GLOBALS['mosConfig_lang'] = strtolower( $lang->getBackwardLang() );
		// Adjust the live site path
		$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
		$mosConfig_absolute_path = JPATH_BASE;
	}
	else
	{
		define('_VALID_MOS', '1');
		require_once($mosConfig_absolute_path. '/includes/joomla.php');
		require_once($mosConfig_absolute_path. '/includes/database.php');
		$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
		$mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path );
	}
	
	// load Joomla Language File
	if (file_exists( $mosConfig_absolute_path.'/language/'.$mosConfig_lang.'.php' ))
		require_once( $mosConfig_absolute_path.'/language/'.$mosConfig_lang.'.php' );
	elseif (file_exists( $mosConfig_absolute_path.'/language/english.php' ))
		require_once( $mosConfig_absolute_path.'/language/english.php' );
	/*** END of Joomla config ***/
	
	
	/*** VirtueMart part ***/
	require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
	include_once( ADMINPATH.'compat.joomla1.5.php' );

	require_once(ADMINPATH. '/classes/htmlTools.class.php');
	require_once(ADMINPATH. '/classes/language.class.php');
	require_once(CLASSPATH."Log/Log.php");
	$vmLoggerConf = array(
		'buffering' => true
	);
	$vmLogger = &vmLog::singleton('display', '', '', $vmLoggerConf, PEAR_LOG_TIP);
	$GLOBALS['vmLogger'] =& $vmLogger;
		
	/* Load the VirtueMart database class */
	require_once( CLASSPATH. 'ps_database.php' );
	$db = new ps_DB;
	
	require_once( ADMINPATH. 'global.php' );
	require_once( CLASSPATH. 'ps_main.php' );
	
	/* Load the Intellectmoney Class File and Configuration File*/
	require_once ( CLASSPATH . 'payment/ps_im.php' );
	require_once ( CLASSPATH . 'payment/ps_im.cfg.php' );
	
	// restart session
	// Constructor initializes the session!
	require_once( CLASSPATH. 'ps_session.php' );
	$sess = new ps_session();
	/*** END VirtueMart part ***/
	
	
	// Получаем информацию о платеже
	$eshopId = trim(stripslashes($_REQUEST['eshopId']));					//1.Номер сайта продавца (eshopId);
	$orderId = trim(stripslashes($_REQUEST['orderId']));					//2.Номер счета продавца (orderId);
	$serviceName = trim(stripslashes($_REQUEST['serviceName']));			//3.Описание покупки (serviceName);
	$eshopAccount = trim(stripslashes($_REQUEST['eshopAccount']));			//4.Номер счета в системе Intellectmoney (eshopAccount);
	$recipientAmount = trim(stripslashes($_REQUEST['recipientAmount']));	//5.Сумма платежа (recipientAmount);
	$recipientCurrency =trim(stripslashes($_REQUEST['recipientCurrency']));//6.Валюта платежа (recipientCurrency);
	$paymentStatus = trim(stripslashes($_REQUEST['paymentStatus']));		//7.Статус платежа (paymentStatus);
	$userName = trim(stripslashes($_REQUEST['userName']));					//8.Имя покупателя (userName);
	$userEmail = trim(stripslashes($_REQUEST['userEmail']));				//9.Email покупателя (userEmail);
	$paymentData = trim(stripslashes($_REQUEST['paymentData']));			//10.Дата и время выполнения платежа(paymentData);
	$secretKey = trim(stripslashes($_REQUEST['secretKey']));				//11.Секретный ключ (secretKey);
	$hash = trim(stripslashes($_REQUEST['hash']));							// Контрольная подпись

	$curs_obmena = trim(stripslashes($_REQUEST['userField_1']));

	// Get the Order Details from the database
	$qv = "SELECT `order_id`, `user_id`, `order_number`, `order_total`, `order_currency`, `order_status`
		FROM `#__{vm}_orders` 
		WHERE `order_number` LIKE '".$orderId."' ";
	$db = new ps_DB();
	$db->query($qv);
	$db->next_record();
	$order_id = $db->f("order_id");
	$order_number = $db->f("order_number");
	$order_total = $db->f("order_total");
	$order_currency = $db->f("order_currency");
	
	$order_total = $order_total * $curs_obmena;
	
	// ORDER ID CHECK
	if(!$order_id) {
		$err = "ERROR: ORDER NOT EXISTS!\n";
		ob_exit($err);
	}
	
	$im = new ps_im();
	$get_amount = number_format($order_total, 2, '.', '');
	$get_currency = strtolower($im->get_currency( $order_currency ));
	$get_currency = ($get_currency == 'rur') ? 'rub' : $get_currency;
	
	// AMOUNT and CURRENCY CODE CHECK
	if( $recipientAmount != $get_amount || strtolower($recipientCurrency) != $get_currency ) {
		$err = "ERROR: AMOUNT/CURRENCY MISMATCH!\n";
		$err .= "recipientAmount: $recipientAmount; amount: $get_amount;\nrecipientCurrency: $recipientCurrency; currency: $get_currency;\n\n";
		ob_exit($err);
	}
	
	if($secretKey)
	{
		//Проверка источника данных (по секретному ключу)
		if ($secretKey != IM_SECRET_KEY) {
			$err = "ERROR: SECRET_KEY MISMATCH!\n";
			$err .= check_im() ? ("secretKey: $secretKey; IM_SECRET_KEY: ".IM_SECRET_KEY.";\n\n") : "\n";
			ob_exit($err);
		}
		
		//Проверка номера сайта продавца
		if ($eshopId != IM_ESHOP_ID) {
			$err = "ERROR: INCORRECT ESHOP_ID!\n";
			$err .= "eshopId: $eshopId; IM_ESHOP_ID: ".IM_ESHOP_ID.";\n\n";
			ob_exit($err);
		}
	}
	else
	{
		//Проверка контрольной подписи
		$control_hash_str = implode('::', array(
			$eshopId, $orderId, $serviceName,
			$eshopAccount, $recipientAmount, $recipientCurrency, $paymentStatus,
			$userName, $userEmail, $paymentData, IM_SECRET_KEY,
		));
		$control_hash = md5($control_hash_str);
		$control_hash_utf8 = md5(iconv('windows-1251', 'utf-8', $control_hash_str));
			
		if (($hash != $control_hash && $hash != $control_hash_utf8) || !$hash) {
			$err = "ERROR: HASH MISMATCH\n";
			$err .= check_im() ? "Control hash string: $control_hash_str;\n" : "";
			$err .= "Control hash win-1251: $control_hash;\nControl hash utf-8: $control_hash_utf8;\nhash: $hash;\n\n";
			ob_exit($err);
		}
	}
	
	if ($paymentStatus == '3' || $paymentStatus == '5')
	{
		$d['order_id'] = $order_id;
		$d['current_order_status'] = $db->f('order_status');
		
		//5 - Платеж зачислен
		if( $paymentStatus == '5' ) {
			$d['order_status'] = PAYPAL_VERIFIED_STATUS;
			$d['order_comment'] = "Платеж зачислен системой Intellectmoney со счета: ".$eshopAccount;
		}
		//3 - Платеж принят на обработку
		elseif( $paymentStatus == '3' ) {
			$d['order_status'] = PAYPAL_PENDING_STATUS;
			$d['order_comment'] = "Платеж принят на обработку системой Intellectmoney со счета: ".$eshopAccount;
		}
		
		require_once ( CLASSPATH . 'ps_order.php' );
		$ps_order = new ps_order();
		$ps_order->order_status_update($d);
		
		// успешно
		ob_exit();
	}
	else
	{
		// не успешно
		ob_exit("ERROR: UNKNOWN PAYMENT STATUS!\n\n");
	}
}

?>